﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Win32;
using Infragistics.Reports.Server;
using Infragistics.Reports;

namespace SampleReport
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
       
        public MainWindow()
        {
            InitializeComponent();                 

            Loaded += MainWindow_Loaded;            
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {                  
           
        }

        private void btnExport_Click(object sender, RoutedEventArgs e)
        {
            // Set PDF format for export
            // should be one within XamReportViewer.AvailableExportFormats
            string exportFormat = "PDF";

            SaveFileDialog saveFileDialog = new SaveFileDialog()
            {
                DefaultExt = exportFormat,
                Filter = "PDF files (*.pdf)|*.pdf|All files (*.*)|*.*",
                FilterIndex = 1
            };

            // Instantiate a SaveFileDialog to specify file destination
            if (saveFileDialog.ShowDialog() == true)
            {
                Stream myStream = null;
                try
                {
                    // Open a file to save the exported report
                    myStream = saveFileDialog.OpenFile();

                    // Invoke Viewer's Exporter
                    this.SampleReport.Export(myStream, exportFormat);
                }
                catch (Exception)
                {
                    //TODO  Handle Exception
                    if (myStream != null)
                        myStream.Close();
                }
            }
        }

        private void SampleReport_ExportCompleted(object sender, Infragistics.Reports.ExportCompletedEventArgs e)
        {
            if (e.Stream != null)
            {
                // Stream needs to be closed
                Dispatcher.BeginInvoke(new Action(() => e.Stream.Close()));
            }
        }


        private void btnExportIGR_Click(object sender, RoutedEventArgs e)
        {
            var reportUri = new Uri("SampleReport;component/SampleReport.igr", UriKind.Relative);           

            using (var exporter = ServerExporterFactory.CreateExporter(reportUri))
            {
                using (FileStream fileStream = new FileStream(@"C:\temp\SamplePDFReport.pdf", FileMode.Create))
                { 
                    exporter.Export(fileStream, "PDF");
                }
            }            
        }        
    }

   
}
