﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace WPF_Reporting_Hier
{
    public class SchoolVM
    {
        
        string[] schNames = { "DelVal", "North", "Chenoweth", "Central", "Pennington", "Horace Greeley", "Trumball", "Ballard", "Auburn", "Breckenridge", "Blake" };
        string[] schBuilt = { "1962", "1978", "1956", "1946", "1982", "1952", "1948", "1947", "1992", "1990", "1985" };
        string[] stdNames = { "John", "Mary", "Jim", "Mike", "Dave", "Al", "Sue", "Sally", "Diane" };
        int[] stdGrades = { 9, 10, 11, 12 };
        Random r = new Random();
        private ObservableCollection<School> schoolList;


        public SchoolVM()
        {
        } 

      
        public  ObservableCollection<School> Schools
        {
            get
            {
                if (schoolList == null)
                    LoadSchools();
                return schoolList;
            }
        }

       
        public void LoadSchools()
        {
            schoolList = new ObservableCollection<School>();

            for (int si=0; si < 10; si++)
            {
                School school = new School(schNames[si], "Admin" + si.ToString(),schBuilt[si]);
                for (int i = 0; i < 5; i++)
                {
                    Student std = new Student(i, stdNames[r.Next(0, 8)], stdGrades[r.Next(0, 4)], "address" + i.ToString(), "city" + i.ToString(), (12345 + i).ToString());
                    school.Students.Add(std);
                }

                schoolList.Add(school);
            }          
        }       
    }


    public class School:INotifyPropertyChanged
    {

        public School()
        {
        }

        public School( string name, string administrator, string built)
        {
            
            this.Name = name;
            this.Administrator = administrator;
            this.Built = built;
             
        }

        string name = string.Empty;
        public string Name
        {
            get { return name; }
            set
            {   name = value;
                NotifyPropertyChanged("Name");
            }
        }

        string built = string.Empty;
        public string Built
        {
            get { return built; }
            set
            {
                built = value;
                NotifyPropertyChanged("Built");
            }
        }
        public string Administrator { get; set; }
        ObservableCollection<Student> stds = new ObservableCollection<Student>();
        public ObservableCollection<Student> Students {
            get
            {
                if (stds == null)
                    new ObservableCollection<Student>();

                return stds;
            }
        }


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        #endregion

    }

    public class Student : INotifyPropertyChanged
    {

        public Student(int id, string name, int grade, string address, string city, string zipcode)
        {
            this.id = id;
            this.Name = name;
            this.Grade = grade;
            this.Address = address;
            this.City = city;
            this.ZipCode = zipcode;
        }


        int id;
        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("ID");
            }
        }

        string name = string.Empty;
        public string Name
        {
            get { return name; }
            set
            {
                name = value;
                NotifyPropertyChanged("Name");
            }
        }
        public int Grade { get; set; }
        public string Address { get; set; }
        public string City { get; set; }
        public string ZipCode { get; set; }



        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        #endregion
    }

   
}
